{
TASK: mirrors
LANG: pascal
}

{$mode objfpc}

uses module;

const
	MAXP=128*4;

var
	n, m, p : integer;
	romeo, juliet, num : integer;
	mirrors, states : array[0..5] of integer;
	Rmirr, Jmirr : array[0..MAXP-1, 0..2] of integer;
	Rnum, Rused : array[0..MAXP-1] of integer;
	Jnum, Jused : array[0..MAXP-1] of integer;
	mirrors_used : array[0..MAXP-1] of integer;

procedure rec2(curr : integer);
var
	i : integer;
begin
	if curr=num then
	begin
		getView(num, mirrors, states, romeo, juliet);
		exit;
	end;

	for i:=0 to 2 do
	begin
		states[curr]:=i;
		rec2(curr+1);
	end;
end;

procedure find_answer(pos : integer)
var
	i : integer;
begin
	for i:=0 to Rnum[pos]-1 do
		mirrors_used[Rmirr[pos, i]]:=1;
	for i:=0 to Jnum[pos]-1 do
		mirrors_used[Jmirr[pos, i]]:=1;

	for i:=0 to p-1 do
		if mirrors_used[i]<>0 then
		begin
			mirrors[num]:=i;
			inc(num, 1);
		end;

	rec2(0);
end;

procedure rec(curr_mirr, next_mirr : integer)
var
	i, j : integer;
begin
	getView(curr_mirr, mirrors, states, romeo, juliet);

	Rused[romeo]:=1;
	Rnum[romeo]:=curr_mirr;
	for i:=0 to curr_mirr-1 do
	Rmirr[romeo, i]:=mirrors[i];

	Jused[juliet]:=1;
	Jnum[juliet]:=curr_mirr;
	for i:=0 to curr_mirr-1 do
		Jmirr[juliet, i]:=mirrors[i];

	if(Jused[romeo]<>0)
		find_answer(romeo);

	if(Rused[juliet]<>0)
		find_answer(juliet);

	if (curr_mirr=3) or (next_mirr==p) then
		exit;

	for i:=next_mirr to p-1 do
		for j:=0 to 2 do
		begin
			mirrors[curr_mirr]:=i;
			states[curr_mirr]:=j;
			rec(curr_mirr+1, i+1);
		end;
end;

begin
	init;

	n=getN;
	m=getM;
	p=getP;

	rec(0, 0);
end.
