/*
TASK: mirrors
LANG: C++
*/

#include <cstdio>
#include <ctime>
#include <cstdlib>

#include "module.h"

#define MAX			128
#define MAX_TIME	20

int n, m, p;
int mirrors[6], states[6];
int henzel, gretel;

void rec(int curr_mirr, int next_mirr)
{
	getView(curr_mirr, mirrors, states, &henzel, &gretel);

	if(curr_mirr==6 || next_mirr==p)
		return;

	for(int i=next_mirr; i<p; i++)
		for(int j=0; j<3; j++)
		{
			mirrors[curr_mirr]=i;
			states[curr_mirr]=j;
			rec(curr_mirr+1, i+1);
		}
}

int main()
{
	clock();

	init();

	p=getP();
	n=getN();
	m=getM();

	rec(0, 0);

	return 0;
}
