#include <iostream>

using namespace std;

int n;
int a[64];
string cat[64];

void init()
{ cin >> n;
  for(int i=1; i<=n; i++)
    cin >> a[i];
  for(int i=1; i<=n; i++)
    if(a[i]<1 || a[i]>n)
    { cout << "a[" << i << "]=" << a[i] << endl;
      return;
    }
  for(int i=1; i<n; i++)
    for(int j=i+1; j<=n; j++)
      if(a[i]==a[j])
      { cout << "a[" << i << "]=a[" << j << "]=" << a[i] << endl;
        return;
      }
    
}

void outCat(int n)
{ int i,j,k,len=30;
  cat[0]=  "1";
  while(cat[0].length()<len) cat[0]="0"+cat[0];
  for(j=1; j<=n; j++)
  {  cat[j]=  "0";
     while(cat[j].length()<len) cat[j]="0"+cat[j];
  }
  for(i=1; i<=n; i++)
    for(j=i; j<=n; j++)
      { int s,c=0;
        for(int k=len-1; k>=0; k--)
        { s = (int(cat[j][k])-int('0')) + (int(cat[j-1][k])-int('0')) + c;
          cat[j][k]=char(int('0')+s%10);
          c = s/10;
        }
      }
      
  i=0;
  while(cat[n][i]=='0') i++;
  cout << cat[n].substr(i,cat[n].length()-i) << endl;
//    for(i=0; i<=n; i++)
//      cout << cat[i] << endl;

}

void outPerm()
{ for(int i=1; i<n; i++)
    cout << a[i] << " ";
  cout << a[n] << endl;
}

bool permOK(int &i, int &j, int &k)
{ for(j=2; j<=n-1; j++)
    for(k=j+1; k<=n; k++)
      if(a[j]>a[k])
        { i=1;
          for(int m=2; m<j; m++)
            if(a[i]<a[m]) i=m;
          if(a[i]>a[j])
            return false;
        }
   return true;
}

void sortPerm(int p, int q)
{ for(int i=p; i<q; i++)
  { int m=i;
    for(int j=i+1; j<=q; j++)
      if(a[m]<a[j]) m=j;
    int w=a[i]; a[i]=a[m]; a[m]=w;
  }
}

void nextPerm(int k, int m)
{ int i,j,w;

  sortPerm(k+1,n);
  if(a[k]<a[k+1] && a[k+1]>m)
  { j=n;
    while(a[j]<=m) j--;
    w=a[k]; a[k]=a[j]; a[j]=w;
    sortPerm(k+1,n);
    i=k+1; j=n;
    while(i<j)
    { w=a[i]; a[i]=a[j]; a[j]=w;
      i++; j--;
    }
    return;
  }

  if(a[k]<a[k+1] && a[k+1]<=m)
  { w=a[k];
    j=k+1;
    while(j<=n && a[j]>w) { 
      a[j-1]=a[j];
      j++;
    }
    a[j-1]=w;
    k--;
  }

  while(a[k]>=a[k+1]) k--;
  if (k==0)
  { for(i=1; i<=n; i++)
      a[i]=i;
    return;
  }

  j=n;
  while(a[k]>=a[j]) j--;
  w=a[k]; a[k]=a[j]; a[j]=w;
  i=k+1; j=n;
  while(i<j)
  { w=a[i]; a[i]=a[j]; a[j]=w;
    i++; j--;
  }
}

int main()
{ int i,j,k,ok;

  init();
  outCat(n);

  if(permOK(i,j,k))
    nextPerm(n-1,a[n-1]);

  while (!permOK(i,j,k))
   { nextPerm(j,a[i]);
   }
   
  outPerm();
  return 0;
}

